unit splitu;

// Please, don't delete this comment. \\
(*
  Copyright Owner: coltishWARE (Kevin Niehage)
  Copyright Year : 2008

  Unit   : splitu (platform independant)
  Version: 1.12

  Contact E-Mail            : development@coltishWARE.com
  Contact Mobile            : +49-(0)-177-69-4321-8
  Contact Telephone Berlin  : +49-(0)-30-69-20-96-78
  Contact Telephone Cottbus : +49-(0)-355-28925-88-17-55
  Contact Telephone Mannheim: +49-(0)-621-483-4664
*)
// Please, don't delete this comment. \\

(*
  Description:

  This unit together with joinu implements a functionality to join/split
  a file to/from another file.
*)

(*
  Change Log:

  [Version 1.12] (17.09.2008: inital release with new header)
  - new coltishWARE header is in place now
  - some rewriting
*)

// DON'T DELETE THIS COMMENT !!!

{----------------------------------------}
{ Unit:      splitu.pas                  }
{ Version:   1.12 (platform independent) }
{                                        }
{ Copyright: coltishWARE                 }
{----------------------------------------}

// DON'T DELETE THIS COMMENT !!!

interface

uses
{$IFDEF MSWINDOWS}
  Windows,
{$ELSE}
  Libc,
{$ENDIF MSWINDOWS}
  SysUtils;

const
  CDefaultBufferSize = 51200;

function SplitFile(const AMainFileName : String; const AJoinedFileName : String; const ARemoveJoinedFileFromMainFile : Boolean; const ASaveJoinedFileToDisk : Boolean; const ABufferSize : LongWord = CDefaultBufferSize) : Boolean;

implementation

function SplitFile(const AMainFileName : String; const AJoinedFileName : String; const ARemoveJoinedFileFromMainFile : Boolean; const ASaveJoinedFileToDisk : Boolean; const ABufferSize : LongWord = CDefaultBufferSize) : Boolean;
  function IntPower(const ABase : Extended; const AExponent : LongInt) : Extended;
  var
    Index : LongWord;
  begin
    Result := 1.0;

    if (AExponent <> 000) then
    begin
      for Index := 001 to Abs(AExponent) do
        Result := Result * ABase;

      if (AExponent < 000) then
        Result := 001 / Result;
    end;
  end;

var
  Buffer           : PChar;
  BufferSize       : LongInt;
  DoneCount        : LongInt;
  HelpChar         : Char;
  HelpString       : String;
  Index            : LongInt;
  JoinedFileHandle : LongInt;
  JoinedFileSize   : LongInt;
  MainFileHandle   : LongInt;
  MainFileSizeA    : LongInt;
  MainFileSizeB    : LongInt;
  WriteCount       : LongInt;
begin
  Result := false;

  if FileExists(AMainFileName) then
  begin
    if ARemoveJoinedFileFromMainFile then
      MainFileHandle := FileOpen(AMainFileName, fmOpenReadWrite or fmShareDenyNone)
    else
      MainFileHandle := FileOpen(AMainFileName, fmOpenRead or fmShareDenyNone);

    if (MainFileHandle >= 0) then
    begin
      try
        MainFileSizeA := FileSeek(MainFileHandle, 0, 2);
        MainFileSizeB := MainFileSizeA;
        FileSeek(MainFileHandle, Pred(MainFileSizeA), 0);
        DoneCount := FileRead(MainFileHandle, HelpChar, 1);
        if (DoneCount = 1) then
        begin
          SetLength(HelpString, Ord(HelpChar));
          FileSeek(MainFileHandle, (Pred(MainFileSizeA) - Length(HelpString)), 0);

          DoneCount := FileRead(MainFileHandle, HelpString[1], Length(HelpString));
          if (DoneCount = Length(HelpString)) then
          begin
            MainFileSizeB := 0;
            for Index := 1 to Length(HelpString) do
              MainFileSizeB :=  MainFileSizeB + (Ord(HelpString[Length(HelpString) - Pred(Index)]) * Trunc(IntPower(Succ(High(Byte)), Pred(Index))));
          end;
        end;

        if ASaveJoinedFileToDisk then
        begin
          if FileExists(AJoinedFileName) then
            JoinedFileHandle := FileOpen(AJoinedFileName, fmOpenWrite or fmShareDenyNone)
          else
            JoinedFileHandle := FileCreate(AJoinedFileName);

          if (JoinedFileHandle >= 0) then
          begin
            try
              JoinedFileSize := MainFileSizeA - MainFileSizeB - Succ(Length(HelpString));
              if (JoinedFileSize > 0) then
              begin
                if (JoinedFileSize < ABufferSize) then
                  BufferSize := JoinedFileSize
                else
                begin
                  if (ABufferSize < 1) then
                    BufferSize := CDefaultBufferSize
                  else
                    BufferSize := ABufferSize;
                end;

                GetMem(Buffer, BufferSize);
                try
                  FileSeek(MainFileHandle, MainFileSizeB, 0);
                  FileSeek(JoinedFileHandle, 0, 0);

                  WriteCount := 0;
                  for Index := 1 to (JoinedFileSize div BufferSize) do
                  begin
                    DoneCount := FileRead(MainFileHandle, Buffer^, BufferSize);
                    if (DoneCount = BufferSize) then
                    begin
                      DoneCount := FileWrite(JoinedFileHandle, Buffer^, BufferSize);
                      begin
                        if (DoneCount = BufferSize) then
                          WriteCount := WriteCount + BufferSize;
                      end;
                    end;
                  end;

                  if ((JoinedFileSize mod BufferSize) <> 0) then
                  begin
                    DoneCount := FileRead(MainFileHandle, Buffer^, (JoinedFileSize mod BufferSize));
                    if (DoneCount = (JoinedFileSize mod BufferSize)) then
                    begin
                      DoneCount := FileWrite(JoinedFileHandle, Buffer^, (JoinedFileSize mod BufferSize));
                      if (DoneCount = (JoinedFileSize mod BufferSize)) then
                        WriteCount := WriteCount + (JoinedFileSize mod BufferSize);
                    end;
                  end;

                  Result := (WriteCount = JoinedFileSize);
                finally
                  FreeMem(Buffer, BufferSize);
                end;
              end;

              FileSeek(JoinedFileHandle, JoinedFileSize, 0);
{$IFDEF MSWINDOWS}
              Result := Result and SetEndOfFile(JoinedFileHandle);
{$ELSE}
              Result := Result and (ftruncate(JoinedFileHandle, JoinedFileSize) >= 0);
{$ENDIF}
            finally
              FileClose(JoinedFileHandle);
            end;
          end;
        end
        else
          Result := true;

        if (Result and ARemoveJoinedFileFromMainFile) then
        begin
          FileSeek(MainFileHandle, MainFileSizeB, 0);

{$IFDEF MSWINDOWS}
          Result := Result and SetEndOfFile(MainFileHandle);
{$ELSE}
          Result := Result and (ftruncate(MainFileHandle, MainFileSizeB) >= 0);
{$ENDIF MSWINDOWS}
        end;
      finally
        FileClose(MainFileHandle);
      end;
    end;
  end;
end;

end.